import { DropdownProps as BaseDropdownProps } from '../../Dropdown/main.js';

export { type DropdownOption } from '../../Dropdown/main.js';
export type DropdownProps<T> = Omit<BaseDropdownProps<T>, "onChange"> & {
    name: string;
};
/**
 * Dropdowns let users select from a list of options.
 *
 * <!-- TODO(ndhoule): Add a screenshot here -->
 *
 * @param props
 * @see {@link Form}
 * @internal
 * @example
 * ```ts
 * import { Dropdown, Form } from "@netlify/sdk/react/components";
 *
 * <Form>
 *   <Dropdown
 *     name="favoriteDog"
 *     options=[
 *       { label: "Pomeranian", value: "pomeranian" },
 *       { label: "Golden Retriever", value: "golden-retriever" },
 *       { label: "Doge", value: "shiba-inu" },
 *     ]
 *   />
 * </Form>
 * ```
 */
export declare const Dropdown: <T, FieldValues extends Record<string, unknown> = Record<string, unknown>>({ name, options, initialSelectedOption, ...otherProps }: DropdownProps<T>) => import("react").JSX.Element;
//# sourceMappingURL=Dropdown.d.ts.map