import { default as React } from 'react';

export type SiteConfigurationSurfaceProps = {
    className?: string | undefined;
    children?: React.ReactNode | undefined;
};
/**
 * A container element used to render the top-level Site Configuration surface. This component
 * will take care of styling your component so it looks good as a site section listed under the
 * top-level navigation for sites in the Netlify UI.
 *
 * <!-- TODO(ndhoule): Add a screenshot here -->
 *
 * @param props
 * @see Surfaces.SiteConfiguration
 * @example
 * ```tsx
 * import { SiteConfigurationSurface } from "@netlify/sdk/react/components";
 *
 * <SiteConfigurationSurface>
 *   <div>Your surface content goes here</div>
 * </SiteConfigurationSurface>
 * ```
 */
export declare const SiteConfigurationSurface: ({ className, children, ...otherProps }: SiteConfigurationSurfaceProps) => React.JSX.Element;
//# sourceMappingURL=SiteConfigurationSurface.d.ts.map